* (Unsigned) Long Compare
*
* V0.00, pjwitte 2oo2
* V0.01, pjw, 2021 Nov 27, LCOMP -> LCMP, tidied + commentary

        section code

        xdef    LCMP

        xref    getpars

*
LCMP
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Compare two unsigned long integers (eg dates!)
*
* result = LCMP(ulong1, ulong2)
*
*       result: ulong1 > ulong2 =>  1
*               ulong1 = ulong2 =>  0
*               ulong1 < ulong2 => -1

        moveq #$26,d0                   get two long words
        bsr getpars
        bne.s exit

        movem.l 0(a6,a1.l),d1/d2
        addq.l #2,$58(a6)               leave room for float return
        move.l $58(a6),a1
        clr.l 2(a6,a1.l)                prepare mantissa

        cmp.l d1,d2
        beq.s eq
        bcs.s gt

        move.l #$08008000,0(a6,a1.l)    float  1

fret
        moveq #2,d4                     flag: float
        moveq #0,d0

exit
        rts

gt
        move.l #$08014000,0(a6,a1.l)    float -1
        bra.s fret

eq
        clr.w 0(a6,a1.l)                exponent float 0
        bra.s fret

*
        end
